LeetCode 278. First Bad Version 第一个错误的版本(Java)

题目:

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, …, n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.

Example:
Given n = 5, and version = 4 is the first bad version.
call isBadVersion(3) -> false
call isBadVersion(5) -> true
call isBadVersion(4) -> true
Then 4 is the first bad version.

解答:

题目很明显需要采用二分法。

/* The isBadVersion API is defined in the parent class VersionControl.
      boolean isBadVersion(int version); */

public class Solution extends VersionControl {
    public int firstBadVersion(int n) {
        int start = 1;
        int end = n;
        while(start<end) {
            int middle=start+(end-start)/2;
            if(isBadVersion(middle)) {
                end=middle;
            } else {
               start=middle+1; 
            }
        }
        return start;
    }
}

但千万要注意,在进行二分查找时,中间数值不能产生溢出

所以上述答案中,应该采用int middle=start+(end-start)/2;
而在第一次提交时,采用 middle=(start+end)/2,产生了溢出错误
LeetCode 278. First Bad Version 第一个错误的版本(Java)_第1张图片
在这里插入图片描述

你可能感兴趣的:(LeetCode)